package ucl.output;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.io.FileUtils;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.engine.environment.RunState;
import repast.simphony.space.grid.Grid;
import ucl.context.ContextCreator;
import ucl.entities.Settlement;
import ucl.model.AgentSettlementModel;
import ucl.model.SettlementModel;

/**
 * Class to output csv data for settlements
 * 
 * @author 
 *
 */
public class Outputter {

	public static int runNumber=0;
	public static boolean started=false;
	
	static String seperator=",";
	static String fileName="."+File.separator+"output"+File.separator+"ModelOutput";
//	static String fieldName=".."+File.separator+"Cities"+File.separator+"output"+File.separator+"FieldOutput";
//	static String titleLine="Tick,X,Y,Size,Flow,Name";
	static String fieldLine="Tick,X,Y,Alpha,Beta,Name,Flow,Size,Population";
	static double alpha,beta,cost,moveProbability,benefitMultiplier;
	static double timeStamp=0;
	
	/**
	 * This method sets up the output to be done.
	 * @param c
	 * @return
	 */
	public static List doOutput(Settlement c){
		List<String>output = new ArrayList<String>();
		String tick=Double.toString(RunEnvironment.getInstance().getCurrentSchedule().
				getTickCount());
		if(Double.parseDouble(tick)==0.0)
			timeStamp=System.currentTimeMillis();
		
		String x=Double.toString(c.getX());
		String y=Double.toString(c.getY());
		
		double alpha=c.alpha;
		double beta=c.beta;
		String name=Integer.toString(c.idN);
		double c1=c.getFlow();
		
		Outputter.alpha=alpha;
		Outputter.beta=beta;
		Outputter.cost=SettlementModel.operationCost;
		Outputter.moveProbability=AgentSettlementModel.moveProbability;
		Outputter.benefitMultiplier=c.getBenefitMultiplier();
		
		String line=tick+seperator+x+seperator+y+seperator+alpha+seperator+beta+seperator+
				name+seperator+c1+seperator+c.size+seperator+c.people.size();
		output.add(line);
		
		return output;
	}
	
	/**
	 * This is the text file data output method.
	 * @param lines
	 */
	public static void writeData(List<String> lines){
		List<String> oldLines=null;
		double tick=RunEnvironment.getInstance().getCurrentSchedule().getTickCount();
		
		if(tick==0.0 && !started){
			new File(fileName+runNumber+".csv").delete();
			started=true;
		}
		if(new File(fileName+runNumber+"_"+Outputter.alpha+"_"+Outputter.beta+"_"+
				Outputter.cost+"_"+Outputter.moveProbability+"_"+Outputter.benefitMultiplier+".csv").exists() && tick>=0){
			try {
				oldLines=FileUtils.readLines(new File(fileName+runNumber+"_"+Outputter.alpha+"_"+Outputter.beta+"_"+
						Outputter.cost+"_"+Outputter.moveProbability+"_"+Outputter.benefitMultiplier+".csv"));
				oldLines.remove(0);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		if(oldLines!=null){
			oldLines.addAll(lines);
			lines=oldLines;
		}
		
		try {
			lines.add(0, fieldLine);
			FileUtils.writeLines(new File(fileName+runNumber+"_"+Outputter.alpha+"_"+Outputter.beta+"_"+
			Outputter.cost+"_"+Outputter.moveProbability+"_"+Outputter.benefitMultiplier+".csv"), lines);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
