package ucl.model;

import static org.junit.Assert.assertTrue;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.junit.Test;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.parameter.ParametersCreator;
import ucl.context.ContextCreator;
import ucl.entities.Agent;
import ucl.entities.Settlement;

/**
 * Test class to look at methods in city model
 * @author 
 *
 */
public class TestSettlementModel {

	// necessary to cities to be tested and their functions
		static {
			ParametersCreator creator = new ParametersCreator();
			creator.addParameter("epsilon", double.class, 1.0, false);
			RunEnvironment.init(null, null, creator.createParameters(), false);
		}
		
		/**
		 * Create people.
		 * @param ps people list
		 * @param n number of people
		 * @param cn site id
		 * @param s settlement
		 */
		public void createPeople(List<Agent>ps,int n, int cn,Settlement s){
			for(int i=0; i < n; i++){
				Agent p = new Agent(n,cn);
				p.benefitMultiplier=1.0;
				p.settlement=s;
				ps.add(p);
			}
		}
		
		/**
		 * Create a settlement
		 */
		public void createSettlement(){
			
			Map<Integer,Double> costs1=new HashMap<Integer,Double>();
			Map<Integer,Double> costs2=new HashMap<Integer,Double>();
			costs1.put(0, 0.0);
			costs1.put(1, 5.0);
			costs2.put(0, 5.5);
			costs2.put(1, 0.0);
			
			
			for(int i=0; i < 2; i++) {
				Settlement s = new Settlement();
				s.setAlpha(1.0);
				s.setBeta(1.0);
				s.setBenefitMultiplier(1.0);
				s.setFlow(1.0);
				s.setIdN(1);
				s.setModel(new SettlementModel());
				s.setName("name");
				List<Agent> ps = new ArrayList<Agent>();
				createPeople(ps,10,i,s);
				s.setPeople(ps);
				s.rangeOfChoice.put(ps.get(0),1.0);
				s.setSize(1.0);
				if(i==0)
					s.setTravelCosts(costs1);
				else
					s.setTravelCosts(costs2);
				ContextCreator.cities.add(s);
			}
		}
		/**
		 * Test calculateSocioEnvironment()
		 */
		@Test
		public void testCalculateSocioEnvironment(){
			SettlementModel acm = new SettlementModel();
			createSettlement();
			Iterator<Settlement>si=ContextCreator.cities.iterator();
			Map<Integer,Integer>numbs=new HashMap<Integer,Integer>();
			while(si.hasNext()){
				Settlement s = si.next();
				acm.calculateSocioEnvironment(s,s.getPeople().get(0));
				assertTrue(s.getRangeOfChoice().get(s.getPeople().get(0))==10);
				
			}
			
		}
		
		/**
		 * Test calculateTotalNetFlow()
		 */
		@Test
		public void testClearFlow(){
			SettlementModel acm = new SettlementModel();
			createSettlement();
			Iterator<Settlement>si=ContextCreator.cities.iterator();
			while(si.hasNext()){
				Settlement s = si.next();
				acm.clearFlow(s);
				assertTrue(s.flow==0);
			}
			
		}
}
